from openerp.addons.web.controllers.main import Reports, serialize_exception
from openerp import http
from openerp.http import request
import simplejson


class Reports(Reports):
    @http.route('/web/report', type='http', auth="user")
    @serialize_exception
    def index(self, action, token):
        try:
            orig_action = action
            action = simplejson.loads(action)
            cr = request.cr
            cr.execute("select id from ir_act_report_xml where report_name IN ('point_of_sale.report_invoice', 'point_of_sale.report_invoice_guarantee');")
            pos_report_invoice_ids = [i[0] for i in cr.fetchall()]
            if action['context']['params']['action'] in pos_report_invoice_ids and action['context'].get('active_model', '') != 'account.invoice':
                orig_order_id = action['context']['active_ids'][0]
                # First check whether we have a return order for this order
                cr.execute("SELECT invoice_id FROM pos_order WHERE return_order_id=%s" % orig_order_id)
                refund_inv_id = cr.fetchone()
                if refund_inv_id:
                    inv_id = refund_inv_id[0]
                else:
                    cr.execute('SELECT invoice_id FROM pos_order WHERE id=%s' % orig_order_id)
                    inv_id = cr.fetchone()[0]
                action['context'].update({
                    'active_model': 'account.invoice',
                    'active_id': inv_id,
                    'active_ids': [inv_id],
                })
                action = simplejson.dumps(action)
            else:
                raise Exception
        except Exception:
            return super(Reports, self).index(orig_action, token)
        else:
            return super(Reports, self).index(action, token)
