# -*- coding: utf-8 -*-
##############################################################################
#
#    Copyright (C) 2014-TODAY Eynes (<http://www.e-mips.com.ar>)
#
#    This is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

import psycopg2


def _update_columns(cr):
    """
    1. Backup the data of card_number to new column card_number_backup
    """
    try:
        # cr.execute("""
        # SELECT column_name
        # FROM information_schema.columns
        # WHERE table_name='pos_order' and column_name='amount_total_2';
        # """)
        # if not cr.rowcount:
        cr.execute("ALTER TABLE account_bank_statement_line ADD COLUMN card_number_backup text;")
        cr.execute("UPDATE account_bank_statement_line SET card_number_backup=card_number;")
    except psycopg2.ProgrammingError:
        cr.rollback()
    else:
        cr.commit()

    return True


def migrate(cr, installed_version):
    return _update_columns(cr)
