# -*- coding: utf-8 -*-

from openerp.osv import osv, fields


class pos_session_opening(osv.osv_memory):
    _inherit = 'pos.session.opening'

    def on_change_config(self, cr, uid, ids, config_id, context=None):
        res = super(pos_session_opening, self).on_change_config(cr, uid, ids, config_id, context)
        user = self.pool['res.users'].browse(cr, uid, uid)
        if user.has_group('point_of_sale.group_pos_user') and user.pos_config:
            res['domain'] = {'pos_config_id': [('id', '=', user.pos_config.id)]}
        return res
